## fdb 5.10.2

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( fdb5 LANGUAGES C CXX )

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

########################################################################################################################
### dependencies and options

### eckit

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_find_package( NAME eckit  VERSION 1.12 REQUIRED )

### GRIB support

ecbuild_find_package( NAME eccodes VERSION 2.10 REQUIRED )

ecbuild_find_package( NAME metkit VERSION 1.5 REQUIRED )

### FDB backend in persistent memory, i.e. pmem (NVRAM)

ecbuild_add_option( FEATURE PMEMFDB # option present in fdb5_config.h
                    DEFAULT OFF
                    DESCRIPTION "Persistent memory (NVRAM) support for FDB"
                    REQUIRED_PACKAGES "NAME pmem" )

### FDB backend in CEPH object store (using Rados)

find_package( RADOS QUIET )
ecbuild_add_option( FEATURE RADOSFDB  # option defined in fdb5_config.h
                    CONDITION eckit_HAVE_RADOS AND RADOS_FOUND
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados support for FDB Store" )

### FDB backend in indexed filesystem with table-of-contents, i.e. TOC
### Supports Lustre parallel filesystem stripping control

ecbuild_add_option( FEATURE TOCFDB  # option defined in fdb5_config.h
                    DEFAULT ON
                    DESCRIPTION "Filesystem TOC support for FDB" )

### support for Lustre API control of file stripping

find_package( LUSTREAPI QUIET )

ecbuild_add_option( FEATURE LUSTRE  # option defined in fdb5_config.h
                    CONDITION LUSTREAPI_FOUND
                    DEFAULT ON
                    DESCRIPTION "Support for Lustre API control of file stripping " )

### experimental & sandbox features

ecbuild_add_option( FEATURE FDB_REMOTE
                    DEFAULT ON
                    DESCRIPTION "Support for FDB remote access" )

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features" )

ecbuild_add_option( FEATURE SANDBOX
                    DESCRIPTION "build the sandbox stuff"
                    DEFAULT OFF	 )

### build the tools

ecbuild_add_option( FEATURE BUILD_TOOLS
                    DEFAULT ON
                    DESCRIPTION "Build the command line tools" )

if(HAVE_BUILD_TOOLS)
    set(_default_fdb_tools ON)
else()
    set(_default_fdb_tools OFF)
endif()

ecbuild_add_option( FEATURE FDB_BUILD_TOOLS
                    DEFAULT ${_default_fdb_tools}
                    DESCRIPTION "Build the command line FDB tools" )

### find thread library ( preferably pthreads )

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package(Threads REQUIRED)

### checks

# check thread library is pthreads

if( NOT ${CMAKE_USE_PTHREADS_INIT} )
	message( FATAL_ERROR "Only pthreads supported - thread library found is [${CMAKE_THREAD_LIBS_INIT}]" )
endif()

########################################################################################################################
# contents

include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings

set( fdb5_INCLUDE_DIRS  ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )

include_directories( ${fdb5_INCLUDE_DIRS} )

set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS};${ECCODES_DEFINITIONS}" )

get_directory_property( fdb5_DEFINITIONS COMPILE_DEFINITIONS )

### source files

add_subdirectory( src )
add_subdirectory( tests )

### finalize

ecbuild_install_project( NAME fdb )

ecbuild_print_summary()

=== src/fdb5/CMakeLists.txt ===
ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/fdb5 )

configure_file( fdb5_config.h.in    fdb5_config.h   )
configure_file( fdb5_version.h.in   fdb5_version.h  )
configure_file( fdb5_version.c.in   ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.c   )

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/fdb5_config.h
               ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.h
         DESTINATION ${INSTALL_INCLUDE_DIR}/fdb5 )

# fdb5 library

list( APPEND fdb5_srcs
    ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.c
	LibFdb5.h
	LibFdb5.cc

    api/fdb_c.cc
    api/fdb_c.h
    api/DistFDB.cc
    api/DistFDB.h
    api/FDB.cc
    api/FDB.h
    api/FDBFactory.cc
    api/FDBFactory.h
    api/FDBStats.cc
    api/FDBStats.h
    api/LocalFDB.cc
    api/LocalFDB.h
    api/RandomFDB.cc
    api/SelectFDB.cc
    api/SelectFDB.h

    api/helpers/APIIterator.h
    api/helpers/ControlIterator.cc
    api/helpers/ControlIterator.h
    api/helpers/FDBToolRequest.cc
    api/helpers/FDBToolRequest.h
    api/helpers/DumpIterator.h
    api/helpers/ListIterator.cc
    api/helpers/ListIterator.h
    api/helpers/StatusIterator.cc
    api/helpers/StatusIterator.h
    api/helpers/WipeIterator.h
    api/helpers/PurgeIterator.h
    api/helpers/StatsIterator.cc
    api/helpers/StatsIterator.h

    api/local/QueryVisitor.h
    api/local/QueueStringLogTarget.h
    api/local/ListVisitor.h
    api/local/ControlVisitor.cc
    api/local/ControlVisitor.h
    api/local/DumpVisitor.h
    api/local/WipeVisitor.cc
    api/local/WipeVisitor.h
    api/local/PurgeVisitor.cc
    api/local/PurgeVisitor.h
    api/local/StatsVisitor.cc
    api/local/StatsVisitor.h
    api/local/StatusVisitor.h

    config/Config.cc
    config/Config.h
    database/Archiver.cc
    database/Archiver.h
    database/ArchiveVisitor.cc
    database/ArchiveVisitor.h
    database/AxisRegistry.cc
    database/AxisRegistry.h
    database/BaseArchiveVisitor.cc
    database/BaseArchiveVisitor.h
    database/Catalogue.cc
    database/Catalogue.h
    database/DB.cc
    database/DB.h
    database/DataStats.cc
    database/DataStats.h
    database/DbStats.cc
    database/DbStats.h
    database/Engine.cc
    database/Engine.h
    database/EntryVisitMechanism.cc
    database/EntryVisitMechanism.h
    database/Field.cc
    database/Field.h
    database/FieldDetails.cc
    database/FieldDetails.h
    database/FieldLocation.cc
    database/FieldLocation.h
    database/UriStore.cc
    database/UriStore.h
    database/Indexer.cc
    database/Indexer.h
    database/Index.cc
    database/Index.h
    database/IndexLocation.cc
    database/IndexLocation.h
    database/IndexStats.cc
    database/IndexStats.h
    database/Inspector.cc
    database/Inspector.h
    database/StatsReportVisitor.cc
    database/StatsReportVisitor.h
    database/Store.cc
    database/Store.h
    database/PurgeVisitor.cc
    database/PurgeVisitor.h
    database/WipeVisitor.cc
    database/WipeVisitor.h
    database/IndexAxis.cc
    database/IndexAxis.h
    database/IndexFactory.cc
    database/IndexFactory.h
    database/Key.cc
    database/Key.h
    database/ReadVisitor.cc
    database/ReadVisitor.h
    database/Report.cc
    database/Report.h
    database/RetrieveVisitor.cc
    database/RetrieveVisitor.h
    database/MultiRetrieveVisitor.cc
    database/MultiRetrieveVisitor.h
    database/WriteVisitor.cc
    database/WriteVisitor.h
    database/Notifier.cc
    database/Notifier.h
    database/Manager.cc
    database/Manager.h
    message/MessageArchiver.cc
    message/MessageArchiver.h
    message/MessageDecoder.cc
    message/MessageDecoder.h
    message/MessageIndexer.cc
    message/MessageIndexer.h
    grib/GribArchiver.h
    io/FDBFileHandle.cc
    io/FDBFileHandle.h
    io/SingleGribMungePartFileHandle.cc
    io/SingleGribMungePartFileHandle.h
    io/LustreFileHandle.cc
    io/LustreFileHandle.h
    io/HandleGatherer.cc
    io/HandleGatherer.h
    rules/MatchAlways.cc
    rules/MatchAlways.h
    rules/MatchAny.cc
    rules/MatchAny.h
    rules/Matcher.cc
    rules/Matcher.h
    rules/MatchHidden.cc
    rules/MatchHidden.h
    rules/MatchOptional.cc
    rules/MatchOptional.h
    rules/MatchValue.cc
    rules/MatchValue.h
    rules/Predicate.cc
    rules/Predicate.h
    rules/Rule.cc
    rules/Rule.h
    rules/Schema.cc
    rules/Schema.h
    rules/SchemaParser.cc
    rules/SchemaParser.h
    tools/FDBTool.cc
    tools/FDBTool.h
    tools/FDBVisitTool.cc
    tools/FDBVisitTool.h
    types/Type.cc
    types/Type.h
    types/TypeAbbreviation.cc
    types/TypeAbbreviation.h
    types/TypeClimateDaily.cc
    types/TypeClimateDaily.h
    types/TypeClimateMonthly.cc
    types/TypeClimateMonthly.h
    types/TypeDate.cc
    types/TypeDate.h
    types/TypeDefault.cc
    types/TypeDefault.h
    types/TypeDouble.cc
    types/TypeDouble.cc
    types/TypeDouble.h
    types/TypeDouble.h
    types/TypeExpver.cc
    types/TypeExpver.h
    types/TypeGrid.cc
    types/TypeGrid.h
    types/TypeIgnore.cc
    types/TypeIgnore.h
    types/TypeInteger.cc
    types/TypeInteger.h
    types/TypeMonth.cc
    types/TypeMonth.h
    types/TypeParam.cc
    types/TypeParam.h
    types/TypesFactory.cc
    types/TypesFactory.h
    types/TypesRegistry.cc
    types/TypesRegistry.h
    types/TypeStep.cc
    types/TypeStep.h
    types/TypeTime.cc
    types/TypeTime.h
)

if(HAVE_FDB_REMOTE)
    list( APPEND fdb5_srcs 
        api/RemoteFDB.cc
        api/RemoteFDB.h

        remote/RemoteConfiguration.h
        remote/RemoteConfiguration.cc
        remote/RemoteFieldLocation.h
        remote/RemoteFieldLocation.cc
        remote/Messages.h
        remote/Messages.cc
        remote/Handler.h
        remote/Handler.cc
        remote/AvailablePortList.cc
        remote/AvailablePortList.h
        remote/FdbServer.h
        remote/FdbServer.cc
    )
endif()

if(HAVE_LUSTRE)
  list( APPEND fdb5_srcs io/fdb5_lustreapi_file_create.c )
endif()

if( HAVE_TOCFDB )
    list( APPEND fdb5_srcs
        toc/AdoptVisitor.cc
        toc/AdoptVisitor.h
        toc/BTreeIndex.cc
        toc/BTreeIndex.h
        toc/Root.cc
        toc/Root.h
        toc/FieldRef.cc
        toc/FieldRef.h
        toc/FileSpaceHandler.cc
        toc/FileSpaceHandler.h
        toc/FileSpace.cc
        toc/FileSpace.h
        toc/ExpverFileSpaceHandler.cc
        toc/ExpverFileSpaceHandler.h
        toc/EnvVarFileSpaceHandler.cc
        toc/EnvVarFileSpaceHandler.h
        toc/RootManager.cc
        toc/RootManager.h
        toc/TocCommon.cc
        toc/TocCommon.h
        toc/TocCatalogue.cc
        toc/TocCatalogue.h
        toc/TocCatalogueReader.cc
        toc/TocCatalogueReader.h
        toc/TocCatalogueWriter.cc
        toc/TocCatalogueWriter.h
        toc/TocFieldLocation.cc
        toc/TocFieldLocation.h
        toc/TocHandler.cc
        toc/TocHandler.h
        toc/TocIndex.cc
        toc/TocIndex.h
        toc/TocIndexLocation.cc
        toc/TocIndexLocation.h
        toc/TocPurgeVisitor.cc
        toc/TocPurgeVisitor.h
        toc/TocWipeVisitor.cc
        toc/TocWipeVisitor.h
        toc/TocRecord.cc
        toc/TocRecord.h
        toc/TocStats.cc
        toc/TocStats.h
        toc/TocStore.cc
        toc/TocStore.h
        toc/TocEngine.cc
        toc/TocEngine.h
        )

    list( APPEND fdb5_tools
        fdb-wipe
        fdb-stats
        fdb-purge
        fdb-dump-toc
        fdb-dump-index
        fdb-reconsolidate-toc )

endif()

if( HAVE_PMEMFDB )

    list( APPEND fdb5_srcs
        pmem/DataPool.cc
        pmem/DataPool.h
        pmem/DataPoolManager.cc
        pmem/DataPoolManager.h
        pmem/MemoryBufferStream.h
        pmem/MemoryBufferStream.cc
        pmem/PBaseNode.cc
        pmem/PBaseNode.h
        pmem/PBranchingNode.cc
        pmem/PBranchingNode.h
        pmem/PDataNode.cc
        pmem/PDataNode.h
        pmem/PDataRoot.cc
        pmem/PDataRoot.h
        pmem/PIndexRoot.cc
        pmem/PIndexRoot.h
        pmem/PMemDB.cc
        pmem/PMemDB.h
        pmem/PMemDBReader.cc
        pmem/PMemDBReader.h
        pmem/PMemDBWriter.cc
        pmem/PMemDBWriter.h
        pmem/PMemFieldLocation.cc
        pmem/PMemFieldLocation.h
        pmem/PMemIndex.cc
        pmem/PMemIndex.h
        pmem/PMemIndexLocation.cc
        pmem/PMemIndexLocation.h
        pmem/PRoot.cc
        pmem/PRoot.h
        pmem/Pool.cc
        pmem/Pool.h
        pmem/PoolEntry.cc
        pmem/PoolEntry.h
        pmem/PoolGroup.cc
        pmem/PoolGroup.h
        pmem/PoolManager.cc
        pmem/PoolManager.h
        pmem/PMemStats.cc
        pmem/PMemStats.h
        pmem/PMemEngine.cc
        pmem/PMemEngine.h
    )

else()
    set( PMEM_LIBRARIES "" )
    set( PMEM_INCLUDE_DIRS "" )
endif()

if( HAVE_RADOSFDB )
    list( APPEND fdb5_srcs
        rados/RadosFieldLocation.cc
        rados/RadosFieldLocation.h
        rados/RadosStore.cc
        rados/RadosStore.h
    )
endif()

ecbuild_add_library(

    TARGET  fdb5

    SOURCES
        ${fdb5_srcs}

    INSTALL_HEADERS LISTED

    HEADER_DESTINATION
        ${INSTALL_INCLUDE_DIR}/fdb5

    PUBLIC_INCLUDES
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>

    PUBLIC_LIBS
        metkit
        eckit
        eckit_option

    PRIVATE_INCLUDES
        "${PMEM_INCLUDE_DIRS}"
        "${LUSTREAPI_INCLUDE_DIRS}"

    PRIVATE_LIBS
        ${grib_handling_pkg}
        ${PMEM_LIBRARIES}
        ${LUSTREAPI_LIBRARIES}
)

if(HAVE_FDB_BUILD_TOOLS)

  list( APPEND fdb5_scripts fdb fdb-which )

  foreach( _script ${fdb5_scripts} )
    configure_file(scripts/${_script}.in ${CMAKE_BINARY_DIR}/bin/${_script} @ONLY)
    install(PROGRAMS ${CMAKE_BINARY_DIR}/bin/${_script} DESTINATION ${INSTALL_BIN_DIR} )
  endforeach()
endif()

list( APPEND fdb5_tools
    fdb-hammer
    fdb-write
    fdb-copy
    fdb-dump
    fdb-list
    fdb-patch
    fdb-read
    fdb-schema
    fdb-where
    fdb-info
    fdb-status
    fdb-lock
    fdb-unlock
)

if ( HAVE_TOCFDB )
    list(APPEND fdb5_tools
        fdb-root
        fdb-overlay
        fdb-hide
    )
endif()

foreach( _tool ${fdb5_tools} )

  ecbuild_add_executable( TARGET    ${_tool}
                          CONDITION HAVE_FDB_BUILD_TOOLS
                          SOURCES   tools/${_tool}.cc
                          INCLUDES  ${ECCODES_INCLUDE_DIRS}  # Please don't remove me, I am needed
                          LIBS      fdb5 )

endforeach()


ecbuild_add_executable( TARGET    grib2fdb5
                        CONDITION HAVE_FDB_BUILD_TOOLS
                        SOURCES   compat/grib2fdb5.cc
                        INCLUDES  ${ECCODES_INCLUDE_DIRS} # Please don't remove me, I am needed
                        LIBS      fdb5 )

ecbuild_add_executable(
        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_FDB_REMOTE
        TARGET fdb-monitor
        SOURCES remote/fdb-monitor.cc
        LIBS eckit eckit_cmd )

ecbuild_add_executable(
        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_FDB_REMOTE
        TARGET fdb-server
        SOURCES
            remote/fdb-server.cc
        LIBS fdb5 )

if ( HAVE_FDB_BUILD_TOOLS )
    target_sources( fdb-lock PRIVATE tools/FDBLock.cc tools/FDBLock.h )
    target_sources( fdb-unlock PRIVATE tools/FDBLock.cc tools/FDBLock.h )
endif()

=== tests/regressions/CMakeLists.txt ===
if (HAVE_FDB_BUILD_TOOLS) # test scripts use the fdb tools
    add_subdirectory(FDB-238)
    add_subdirectory(FDB-239)
    add_subdirectory(FDB-240)
    add_subdirectory(FDB-241)
    add_subdirectory(FDB-243)
    add_subdirectory(FDB-251)
    add_subdirectory(FDB-258)
    add_subdirectory(FDB-260)
    add_subdirectory(FDB-264)
    add_subdirectory(FDB-266)
    add_subdirectory(FDB-267)
    add_subdirectory(FDB-268)
    add_subdirectory(FDB-271)
    add_subdirectory(FDB-275)
    add_subdirectory(FDB-276)
    add_subdirectory(FDB-282)
endif()

=== tests/regressions/FDB-271/CMakeLists.txt ===
ecbuild_configure_file( FDB-271.sh.in FDB-271.sh @ONLY )

if( CMAKE_SYSTEM_NAME MATCHES "Linux" )
    ecbuild_add_test(
        TYPE     SCRIPT
        COMMAND  FDB-271.sh )
endif()

=== debian/changelog ===
fdb (5.10.2-1) unstable; urgency=medium

  * New upstream release
  * Now build-dep on libmetkit-dev >= 1.8.10
  * Start bash-completion scripts	

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 01 Feb 2022 09:45:37 +0000

fdb (5.9.2-2) unstable; urgency=medium

  * Drop 32-bit archs as eckit is now 64-bit only

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 11 Oct 2021 10:16:07 +0100

fdb (5.9.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 22 Sep 2021 09:42:48 +0100

fdb (5.8.6-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 16 Aug 2021 05:18:15 +0100

fdb (5.8.6-1) experimental; urgency=medium

  * New upstream release
  * Fix typo in d/rules to enable PMEM where possible

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 22 Jun 2021 09:51:58 +0100

fdb (5.8.4-1) experimental; urgency=medium

  * New upstream release
  * Include orig-data.tar.xz for regression tests

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Jun 2021 08:53:45 +0100

fdb (5.8.2-1) experimental; urgency=medium

  * New upstream release
  * Drop obsolete adjust-metkit-changes.patch
  * Enable tests with lib path in d/rules

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 01 Jun 2021 12:55:33 +0100

fdb (5.8.0-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 07 May 2021 14:33:44 +0100

fdb (5.7.0-6) unstable; urgency=medium

  * QA upload.

  [ Sergio Durigan Junior ]
  * d/p/adjust-metkit-changes.patch: Adjust code to reflect metkit changes.
    Fix FTBFS. (Closes: #987934)

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 03 May 2021 16:05:26 +0200

=== debian/control ===
Source: fdb
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (=13),
 ecbuild (>= 3.3.0-3),
 libeckit-dev,
 libeccodes-dev,
 libopenjp2-7-dev,
 libmetkit-dev,
 libodc-dev,
 libmetkit-utils (>= 1.8.10~1~),
 libpmem-dev [amd64 arm64 ppc64el],
 librados-dev [!hurd-i386  !kfreebsd-amd64 !kfreebsd-i386  !sh4 !ia64 !alpha !hppa ] ,
 libeccodes-tools
Standards-Version: 4.5.1
Homepage: https://github.com/ecmwf/fdb
Vcs-Browser: https://salsa.debian.org:/science-team/fdb.git
Vcs-Git: https://salsa.debian.org:/science-team/fdb.git -b debian/latest

Package: libfdb5-0d
Section: libs
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library for the ECMWF Fields Database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.

Package: libfdb5-dev
Section: libdevel
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
Multi-Arch: same
Depends: libfdb5-0d (= ${binary:Version}), 
  ${misc:Depends}, libeckit-dev
Recommends: pkg-config
Description: Development files for the ECMWF Fields database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.
 .
 This package provides shared libraries and headers.

Package: fdb5
Multi-Arch: foreign
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
Depends: libfdb5-0d ( = ${binary:Version}), 
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libfdb5-dev (= ${binary:Version})
Description: Utilities for the FDB Fields Database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

ARCH:=$(shell dpkg --print-architecture)
LIBDIR:=/usr/lib/${DEB_HOST_MULTIARCH}
DESTDIR:=$(CURDIR)/debian/tmp
BUILDDIR:=debian/build

ARCH_PMEM:= amd64 arm64 ppc64el
DO_PMEM:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_PMEM)),ON,OFF)

ARCH_NORADOS:= hurd-i386 kfreebsd-amd64 kfreebsd-i386 sh4 ia64 alpha hppa
DO_RADOS:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NORADOS)),OFF,ON)

# The magic debhelper  rule
%:
	dh $@ --buildsystem=ecbuild --builddirectory=debian/build


CMAKE_CFLAGS:=  -DENABLE_RPATHS=OFF \
		-DENABLE_RELATIVE_RPATHS=OFF \
		-DENABLE_PMEMFDB=$(DO_PMEM)  \
		-DENABLE_RADOSFDB=$(DO_RADOS) \
		-DENABLE_LUSTRE=ON 

override_dh_auto_configure:
	mkdir -p  $(BUILDDIR)/data  
	( cd $(BUILDDIR)/data ; tar axpf $(CURDIR)/../fdb_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )
	dh_auto_configure -- \
                      ${BUILD_FLAGS}


override_dh_auto_test:
	LD_LIBRARY_PATH=$(BUILDDIR)/lib dh_auto_test ||  echo "Ignoring test failures"

## fdb 5.10.8

=== src/fdb5/CMakeLists.txt ===
--- 
+++ 
@@ -225,7 +225,7 @@
     )
 endif()
 
-if(HAVE_LUSTRE)
+if(fdb5_HAVE_LUSTRE)
   list( APPEND fdb5_srcs io/fdb5_lustreapi_file_create.c )
 endif()

=== tests/fdb/CMakeLists.txt ===
configure_file( etc/mars/wind    ${CMAKE_BINARY_DIR}/etc/mars/wind     @ONLY )

configure_file( etc/fdb/schema   ${CMAKE_BINARY_DIR}/etc/fdb/schema    @ONLY )
configure_file( etc/fdb/engines  ${CMAKE_BINARY_DIR}/etc/fdb/engines   @ONLY )

# for file based FDB
configure_file( etc/fdb/dbnames  ${CMAKE_BINARY_DIR}/etc/fdb/dbnames   @ONLY )
configure_file( etc/fdb/roots    ${CMAKE_BINARY_DIR}/etc/fdb/roots     @ONLY )
configure_file( etc/fdb/spaces   ${CMAKE_BINARY_DIR}/etc/fdb/spaces    @ONLY )

file( MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/tests/fdb/root ) # as defined in ${CMAKE_BINARY_DIR}/etc/fdb/roots file

# for pmem based FDB
configure_file( etc/fdb/pools      ${CMAKE_BINARY_DIR}/etc/fdb/pools       @ONLY )
configure_file( etc/fdb/poolgroups ${CMAKE_BINARY_DIR}/etc/fdb/poolgroups  @ONLY )

file( MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/tests/fdb/pool ) # as defined in ${CMAKE_BINARY_DIR}/etc/fdb/pools file

###############################################################################
# fdb unit tests

list( APPEND _test_environment
    FDB_HOME=${CMAKE_BINARY_DIR}
    ECCODES_DEFINITION_PATH=${ECCODES_DEFINITION_PATH}
    ECCODES_SAMPLES_PATH=${ECCODES_SAMPLES_PATH} )

list( APPEND fdb_tests
    test_fdb5_service.cc )

foreach( _tst ${fdb_tests} )

  get_filename_component(_test_name ${_tst} NAME_WE)

  ecbuild_add_test(
      TARGET  fdb5_${_test_name}
      SOURCES  ${_tst}
      INCLUDES ${ECCODES_INCLUDE_DIRS}
      ENVIRONMENT "${_test_environment}"
      LIBS  fdb5 )

endforeach()

###############################################################################
# fdb tool tests

list( APPEND _test_data
  "rd.vod.grib"
)

ecbuild_get_test_multidata( TARGET fdb5_get_test_data NAMES ${_test_data} )

foreach( _tst ${_test_data} )

    # define tool location using cmake-generator-expressions
    # see https://cmake.org/cmake/help/v3.4/manual/cmake-generator-expressions.7.html

    ecbuild_add_test(
        TARGET  fdb5_archive_${_tst}
        CONDITION HAVE_FDB_BUILD_TOOLS
        COMMAND $<TARGET_FILE:fdb-write>
        TEST_DEPENDS fdb5_get_test_data
        ARGS    ${_tst}
        ENVIRONMENT "${_test_environment}" )

      ecbuild_add_test(
          TARGET  fdb5_extract_${_tst}
          CONDITION HAVE_FDB_BUILD_TOOLS
          COMMAND $<TARGET_FILE:fdb-read>
          TEST_DEPENDS fdb5_archive_${_tst}
          ARGS   --extract ${_tst} ${_tst}.2
          ENVIRONMENT "${_test_environment}" )

endforeach()

#################################################################################
# pmem tests make use of the test environment, so are added at the end

add_subdirectory( pmem )
add_subdirectory( api )
add_subdirectory( tools )
add_subdirectory( type )

=== tests/regressions/CMakeLists.txt ===
--- 
+++ 
@@ -15,4 +15,6 @@
     add_subdirectory(FDB-275)
     add_subdirectory(FDB-276)
     add_subdirectory(FDB-282)
+    add_subdirectory(FDB-291)
+    add_subdirectory(FDB-292)
 endif()

=== tests/fdb/api/CMakeLists.txt ===
### test data files
list( APPEND fdb_api_test_data_files
x138-300.grib
x138-400.grib
y138-400.grib
)

list( APPEND _test_environment
    ECCODES_DEFINITION_PATH=${ECCODES_DEFINITION_PATH}
    ECCODES_SAMPLES_PATH=${ECCODES_SAMPLES_PATH} )

ecbuild_get_test_multidata( TARGET get_fdb_api_test_data
                            NAMES ${fdb_api_test_data_files}
                            NOCHECK )

list( APPEND api_tests
    config
    select
    dist
    fdb_c
)

foreach( _test ${api_tests} )

    ecbuild_add_test( TARGET test_fdb5_api_${_test}
                      SOURCES test_${_test}.cc
                      TEST_DEPENDS get_fdb_api_test_data
                      LIBS fdb5
                      ENVIRONMENT "${_test_environment}" )

endforeach()

=== tests/fdb/type/CMakeLists.txt ===
list( APPEND type_tests
    toKey
)

foreach( _test ${type_tests} )

    ecbuild_add_test( TARGET test_fdb5_type_${_test}
                      SOURCES test_${_test}.cc
                      LIBS fdb5)

endforeach()

=== tests/regressions/FDB-251/CMakeLists.txt ===
ecbuild_configure_file( FDB-251.sh.in FDB-251.sh @ONLY )

ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  FDB-251.sh )

=== tests/regressions/FDB-266/CMakeLists.txt ===
ecbuild_configure_file( FDB-266.sh.in FDB-266.sh @ONLY )

ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  FDB-266.sh )

=== tests/regressions/FDB-275/CMakeLists.txt ===
ecbuild_configure_file( FDB-275.sh.in FDB-275.sh @ONLY )

ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  FDB-275.sh )

=== debian/changelog ===
fdb (5.10.8-2) unstable; urgency=medium

  * Fix includes in cmake files

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 31 Aug 2022 18:07:03 +0100

fdb (5.10.8-1) unstable; urgency=medium

  * New upstream release
  * Ship example conf files in /etc/fdb/*
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 08 Jun 2022 10:25:55 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  libpmem-dev [amd64 arm64 ppc64el],
  librados-dev [!hurd-i386  !kfreebsd-amd64 !kfreebsd-i386  !sh4 !ia64 !alpha !hppa ] ,
  libeccodes-tools
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Homepage: https://github.com/ecmwf/fdb
 Vcs-Browser: https://salsa.debian.org:/science-team/fdb.git
 Vcs-Git: https://salsa.debian.org:/science-team/fdb.git -b debian/latest

=== debian/rules ===
--- 
+++ 
@@ -35,6 +35,11 @@
                       ${BUILD_FLAGS}
 
 
+override_dh_auto_install:
+	dh_auto_install --builddirectory=debian/build
+	# Fixup cmake files. Hack. can we do better with patches to upstream ?
+	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(DESTDIR)/$(LIBDIR)/cmake/fdb5/fdb5-targets.cmake
+
 override_dh_auto_test:
 	LD_LIBRARY_PATH=$(BUILDDIR)/lib dh_auto_test ||  echo "Ignoring test failures"

## fdb 5.11.7

=== debian/changelog ===
fdb (5.11.7-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 10 Mar 2023 11:15:02 +0000

## fdb 5.11.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,17 @@
 cmake_minimum_required( VERSION 3.12 FATAL_ERROR )
 
-find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)
+find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)
 
 project( fdb5 LANGUAGES C CXX )
 
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
+
+CHECK_TYPE_SIZE(off_t SIZEOF_OFF_T)
+
+if ("${SIZEOF_OFF_T}" LESS 8)
+    MESSAGE(SEND_ERROR "Missing support for large files (off_t size < 64 bits)")
+endif()
 
 ########################################################################################################################
 ### dependencies and options
@@ -18,7 +24,12 @@
 
 ### GRIB support
 
-ecbuild_find_package( NAME eccodes VERSION 2.10 REQUIRED )
+ecbuild_find_package( NAME eccodes VERSION 2.10 QUIET )
+
+ecbuild_add_option( FEATURE GRIB
+                    DEFAULT ON
+                    CONDITION eccodes_FOUND
+                    DESCRIPTION "Support for GRIB via eccodes")
 
 ecbuild_find_package( NAME metkit VERSION 1.5 REQUIRED )

=== src/fdb5/CMakeLists.txt ===
--- 
+++ 
@@ -39,7 +39,8 @@
     api/helpers/DumpIterator.h
     api/helpers/ListIterator.cc
     api/helpers/ListIterator.h
-    api/helpers/StatusIterator.cc
+    api/helpers/LockIterator.h
+    api/helpers/MoveIterator.h
     api/helpers/StatusIterator.h
     api/helpers/WipeIterator.h
     api/helpers/PurgeIterator.h
@@ -54,6 +55,8 @@
     api/local/DumpVisitor.h
     api/local/WipeVisitor.cc
     api/local/WipeVisitor.h
+    api/local/MoveVisitor.cc
+    api/local/MoveVisitor.h
     api/local/PurgeVisitor.cc
     api/local/PurgeVisitor.h
     api/local/StatsVisitor.cc
@@ -108,6 +111,8 @@
     database/PurgeVisitor.h
     database/WipeVisitor.cc
     database/WipeVisitor.h
+    database/MoveVisitor.cc
+    database/MoveVisitor.h
     database/IndexAxis.cc
     database/IndexAxis.h
     database/IndexFactory.cc
@@ -134,12 +139,10 @@
     message/MessageDecoder.h
     message/MessageIndexer.cc
     message/MessageIndexer.h
-    grib/GribArchiver.h
     io/FDBFileHandle.cc
     io/FDBFileHandle.h
-    io/SingleGribMungePartFileHandle.cc
-    io/SingleGribMungePartFileHandle.h
-    io/LustreFileHandle.cc
+    io/LustreSettings.cc
+    io/LustreSettings.h
     io/LustreFileHandle.h
     io/HandleGatherer.cc
     io/HandleGatherer.h
@@ -229,6 +232,13 @@
   list( APPEND fdb5_srcs io/fdb5_lustreapi_file_create.c )
 endif()
 
+if ( HAVE_GRIB )
+    list( APPEND fdb5_srcs
+        io/SingleGribMungePartFileHandle.cc
+        io/SingleGribMungePartFileHandle.h
+    )
+endif()
+
 if( HAVE_TOCFDB )
     list( APPEND fdb5_srcs
         toc/AdoptVisitor.cc
@@ -267,8 +277,12 @@
         toc/TocIndexLocation.h
         toc/TocPurgeVisitor.cc
         toc/TocPurgeVisitor.h
+        toc/TocSerialisationVersion.cc
+        toc/TocSerialisationVersion.h
         toc/TocWipeVisitor.cc
         toc/TocWipeVisitor.h
+        toc/TocMoveVisitor.cc
+        toc/TocMoveVisitor.h
         toc/TocRecord.cc
         toc/TocRecord.h
         toc/TocStats.cc
@@ -285,8 +299,8 @@
         fdb-purge
         fdb-dump-toc
         fdb-dump-index
-        fdb-reconsolidate-toc )
-
+        fdb-reconsolidate-toc
+        fdb-move )
 endif()
 
 if( HAVE_PMEMFDB )
@@ -353,6 +367,8 @@
 ecbuild_add_library(
 
     TARGET  fdb5
+    
+    TYPE SHARED # Library needs to be shared for dynamic factory self registration
 
     SOURCES
         ${fdb5_srcs}
@@ -370,6 +386,7 @@
         metkit
         eckit
         eckit_option
+        eckit_mpi
 
     PRIVATE_INCLUDES
         "${PMEM_INCLUDE_DIRS}"
@@ -392,12 +409,10 @@
 endif()
 
 list( APPEND fdb5_tools
-    fdb-hammer
     fdb-write
     fdb-copy
     fdb-dump
     fdb-list
-    fdb-patch
     fdb-read
     fdb-schema
     fdb-where
@@ -407,6 +422,13 @@
     fdb-unlock
 )
 
+if ( HAVE_GRIB )
+    list( APPEND fdb5_tools
+        fdb-hammer
+        fdb-patch
+    )
+endif()
+
 if ( HAVE_TOCFDB )
     list(APPEND fdb5_tools
         fdb-root
@@ -425,6 +447,9 @@
 
 endforeach()
 
+if (eckit_HAVE_MPI AND HAVE_FDB_BUILD_TOOLS)
+    target_link_libraries( fdb-move eckit_mpi )
+endif()
 
 ecbuild_add_executable( TARGET    grib2fdb5
                         CONDITION HAVE_FDB_BUILD_TOOLS
@@ -433,7 +458,7 @@
                         LIBS      fdb5 )
 
 ecbuild_add_executable(
-        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_FDB_REMOTE
+        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_FDB_REMOTE AND eckit_HAVE_ECKIT_CMD
         TARGET fdb-monitor
         SOURCES remote/fdb-monitor.cc
         LIBS eckit eckit_cmd )

=== tests/regressions/CMakeLists.txt ===
if (HAVE_FDB_BUILD_TOOLS) # test scripts use the fdb tools

    if (HAVE_GRIB)
        add_subdirectory(FDB-238)
        add_subdirectory(FDB-239)
        add_subdirectory(FDB-240)
        add_subdirectory(FDB-243)
        add_subdirectory(FDB-245)
        add_subdirectory(FDB-251)
        add_subdirectory(FDB-258)
        add_subdirectory(FDB-260)
        add_subdirectory(FDB-264)
        add_subdirectory(FDB-266)
        add_subdirectory(FDB-267)
        add_subdirectory(FDB-268)
        add_subdirectory(FDB-271)
        add_subdirectory(FDB-275)
        add_subdirectory(FDB-276)
        add_subdirectory(FDB-282)
        add_subdirectory(FDB-291)
        add_subdirectory(FDB-292)
        add_subdirectory(FDB-307)
    endif()

    add_subdirectory(FDB-241)

endif()

=== debian/changelog ===
fdb (5.11.17-1build1) mantic; urgency=medium

  * Rebuild against new eccodes drop on armhf and s390x.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 20 Jul 2023 07:05:15 +0200

fdb (5.11.17-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 14 Jun 2023 08:58:24 +0100

fdb (5.11.14-2) unstable; urgency=medium

  * Push to unstable
  * Debhelper needs to be =13

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 11 Jun 2023 12:30:36 +0100

fdb (5.11.14-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 18 May 2023 09:13:27 +0100

fdb (5.11.10-1) experimental; urgency=medium

  * New upstream release
  * Debhelper compat level 15

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 08 May 2023 10:06:19 +0100

fdb (5.11.7-2) experimental; urgency=medium

  * Standards-Version: 4.6.2
  * Rebuild against latest eckit

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 10 Apr 2023 11:06:55 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (=13),
  ecbuild (>= 3.3.0-3),
- libeckit-dev,
+ libeckit-dev (>= 1.23.0-1~),
  libeccodes-dev,
  libopenjp2-7-dev,
  libmetkit-dev,
@@ -13,7 +13,7 @@
  libpmem-dev [amd64 arm64 ppc64el],
  librados-dev [!hurd-i386  !kfreebsd-amd64 !kfreebsd-i386  !sh4 !ia64 !alpha !hppa ] ,
  libeccodes-tools
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/ecmwf/fdb
 Vcs-Browser: https://salsa.debian.org:/science-team/fdb.git
 Vcs-Git: https://salsa.debian.org:/science-team/fdb.git -b debian/latest

## fdb 5.11.104

=== debian/changelog ===
fdb (5.11.104-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 24 Feb 2024 08:24:12 +0000

fdb (5.11.103-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 23 Feb 2024 08:52:31 +0000

fdb (5.11.101-1) unstable; urgency=medium

  * New upstream release
  * Move from pkg-config to pkgconf
  * Remove RPATH from fdb-move

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 22 Feb 2024 09:03:59 +0000

fdb (5.11.99-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 13 Jan 2024 08:37:24 +0000

fdb (5.11.98-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 05 Jan 2024 06:33:55 +0000

fdb (5.11.94-1) unstable; urgency=medium

  * New upstream release. Closes: #1058345

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Dec 2023 08:13:59 +0000

fdb (5.11.25-1) unstable; urgency=medium

  * New upstream release
  * Switch to arch: any instead of hard-coded  arch list
  * Update NORADOS arch list in d/rules

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 03 Nov 2023 09:39:40 +0000

fdb (5.11.23-2) unstable; urgency=medium

  * B-D on architecture-is-64-bit, drop arch deps on librados-dev,
    build with libpmem-dev on riscv64

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 28 Sep 2023 16:25:50 +0100

fdb (5.11.23-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 18 Sep 2023 10:50:22 +0100

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (=13),
+ architecture-is-64-bit,
  ecbuild (>= 3.3.0-3),
  libeckit-dev (>= 1.23.0-1~),
  libeccodes-dev,
@@ -10,8 +11,8 @@
  libmetkit-dev,
  libodc-dev,
  libmetkit-utils (>= 1.8.10~1~),
- libpmem-dev [amd64 arm64 ppc64el],
- librados-dev [!hurd-i386  !kfreebsd-amd64 !kfreebsd-i386  !sh4 !ia64 !alpha !hppa ] ,
+ libpmem-dev [amd64 arm64 ppc64el riscv64],
+ librados-dev [!sparc64 !ppc64 !alpha !loong64],
  libeccodes-tools
 Standards-Version: 4.6.2
 Homepage: https://github.com/ecmwf/fdb
@@ -20,7 +21,7 @@
 
 Package: libfdb5-0d
 Section: libs
-Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
+Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Library for the ECMWF Fields Database
@@ -33,11 +34,11 @@
 
 Package: libfdb5-dev
 Section: libdevel
-Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
+Architecture: any
 Multi-Arch: same
 Depends: libfdb5-0d (= ${binary:Version}), 
   ${misc:Depends}, libeckit-dev
-Recommends: pkg-config
+Recommends: pkgconf
 Description: Development files for the ECMWF Fields database
  FDB (Fields DataBase) is a domain-specific object store developed
  at ECMWF for storing, indexing and retrieving GRIB data. 
@@ -50,7 +51,7 @@
 
 Package: fdb5
 Multi-Arch: foreign
-Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
+Architecture: any
 Depends: libfdb5-0d ( = ${binary:Version}), 
   ${shlibs:Depends}, ${misc:Depends}
 Recommends: libfdb5-dev (= ${binary:Version})
